unit Main;

interface                                                    

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, ToolWin, ExtCtrls, ShellAPI, Buttons, StdCtrls, FileCtrl,
  INIFiles, dfsStatusBar, CheckLst, FileUtility, ImgList,PrevAppRepeat, Projects,
  Registry; {For Win32}
  //IniFiles; {For Win16}

const
  WM_Userdef = WM_USER + 1;
  IconTop=40;
  WeekDay:Array[1..7] of String=('Sunday','Monday','Tuesday','Wednesday','Thirsday','Friday','Saturday');
  iSecTolerance=2; //BackUp Files Ʈe\~t
  Folders=0;
  Files=1;

{$IFNDEF WIN32}
  const MAX_PATH = 144;
{$ENDIF}

type
  TMainForm = class(TForm)
    MinImage: TImage;
    CloseImage: TImage;
    MenuImage: TImage;
    btnAdd: TBitBtn;
    btnDelete: TBitBtn;
    btnselDir: TBitBtn;
    btnRestore: TBitBtn;
    BtnDelBkUp: TBitBtn;
    btnBackUp: TBitBtn;
    pnlAutoBkUp: TPanel;
    cbxBkupType: TComboBox;
    cbxDay: TComboBox;
    cbxTime: TComboBox;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    btnSetTime: TBitBtn;
    ToolBar1: TToolBar;
    tbtnStop: TToolButton;
    tbtnRun: TToolButton;
    lblAutobkup: TLabel;
    RatMenu: TPopupMenu;
    cmHide: TMenuItem;
    cmQuit: TMenuItem;
    MenuItem1: TMenuItem;
    cmAbout: TMenuItem;
    opdlg1: TOpenDialog;
    opdlg2: TOpenDialog;
    filemenu: TPopupMenu;
    File1: TMenuItem;
    OpenProject1: TMenuItem;
    N6: TMenuItem;
    Edit1: TMenuItem;
    AddSourceFiles1: TMenuItem;
    DeleteSelectedSourceFiles1: TMenuItem;
    BackUpAll1: TMenuItem;
    N3: TMenuItem;
    RestoreSelectedFiles1: TMenuItem;
    DeleteSelectedBackupFiles1: TMenuItem;
    SelectBackUpDirectory1: TMenuItem;
    N5: TMenuItem;
    Display1: TMenuItem;
    Hide1: TMenuItem;
    Transparent1: TMenuItem;
    Opaque1: TMenuItem;
    N7: TMenuItem;
    RandomSkin1: TMenuItem;
    N8: TMenuItem;
    ChangeSkin1: TMenuItem;
    About1: TMenuItem;
    N4: TMenuItem;
    Exit1: TMenuItem;
    Timer1: TTimer;
    ImageList1: TImageList;
    pnlClock: TPanel;
    lblClock: TLabel;
    lbxSource: TListBox;
    lbxTarget: TListBox;
    edTarget: TEdit;
    stTarget: TStaticText;
    DefaultSkin1: TMenuItem;
    lbStatus: TStaticText;
    TimelyChange1: TMenuItem;
    btnBackPrjDir: TBitBtn;
    N10: TMenuItem;
    N11: TMenuItem;
    RoundedWindow1: TMenuItem;
    N2: TMenuItem;
    ComponetsHideShow1: TMenuItem;
    N13: TMenuItem;
    Tools1: TMenuItem;
    SetcurrentSkinasWallPaper1: TMenuItem;
    ClearWallPaper1: TMenuItem;
    cbxProjects: TComboBox;
    N1: TMenuItem;
    RunEzBkUponWindowsStartUp1: TMenuItem;
    edBkUp: TEdit;
    DisableAutoStarUp1: TMenuItem;
    N9: TMenuItem;
    DosMode1: TMenuItem;
    N12: TMenuItem;
    HideIE1: TMenuItem;
    ScreenSaverOn1: TMenuItem;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure FormCreate(Sender: TObject);
    procedure RatMenuPopup(Sender: TObject);
    procedure Hide1Click(Sender: TObject);
    procedure cmQuitClick(Sender: TObject);
    procedure cmHideClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure MinImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MinImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MinImageClick(Sender: TObject);
    procedure CloseImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CloseImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CloseImageClick(Sender: TObject);
    procedure MenuImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MenuImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnselDirClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OpenProject1Click(Sender: TObject);
    procedure btnRestoreClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure BtnDelBkUpClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure btnBackUpClick(Sender: TObject);
    procedure cbxBkupTypeChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure RandomSkin1Click(Sender: TObject);
    procedure ChangeSkin1Click(Sender: TObject);
    procedure MenuImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure MinImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CloseImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure tbtnStopRunClick(Sender: TObject);
    procedure Transparent1Click(Sender: TObject);
    procedure Opaque1Click(Sender: TObject);
    procedure btnSetTimeClick(Sender: TObject);
    procedure cbxDayChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure cbxTimeChange(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MenuImageClick(Sender: TObject);
    procedure lbxSourceKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbxTargetKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DefaultSkin1Click(Sender: TObject);
    procedure cmAboutClick(Sender: TObject);
    procedure TimelyChange1Click(Sender: TObject);
    procedure lbxSourceMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure lbxTargetMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure btnBackPrjDirClick(Sender: TObject);
    procedure lbxTargetDblClick(Sender: TObject);
    procedure lbxtMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RoundedWindow1Click(Sender: TObject);
    procedure ShowBkgndPic(blShow:Boolean);
    procedure ComponetsHideShow1Click(Sender: TObject);
    procedure SetcurrentSkinasWallPaper1Click(Sender: TObject);
    procedure ClearWallPaper1Click(Sender: TObject);
    procedure cbxProjectsChange(Sender: TObject);
    procedure RunEzBkUponWindowsStartUp1Click(Sender: TObject);
    procedure DisableAutoStarUp1Click(Sender: TObject);
    procedure lbxSourceDblClick(Sender: TObject);
    procedure DosMode1Click(Sender: TObject);
    procedure HideIE1Click(Sender: TObject);
    procedure ScreenSaverOn1Click(Sender: TObject);
    
  private
    { Private declarations }
    
    procedure WMNCHitTest(var Msg: TWMNCHitTest); message WM_NCHitTest;
    procedure IconCallBackMessage( var Msg : TMessage ); message WM_Userdef;
    procedure WMTIMECHANGE(var Message: TWMTIMECHANGE);  message WM_TIMECHANGE;


    procedure ReadEzBkUp_Ini;
    procedure WriteEzBkUp_Ini;
    procedure ListProjects;

    procedure WritePrj_Ini(PrjFn:string);
    procedure GetSourceFiles(PrjFn:string; var head,tail:Fileptr);
    procedure ListSourceFiles(head,tail:Fileptr);

    procedure ListBackUpDirs(PrjDir:string);
    procedure GetBackUpFiles(BkUpDir:string; var head,tail:Fileptr);
    procedure ListBackUpFiles(head,tail:Fileptr);

    procedure BackUpFiles(head,tail:Fileptr; PrjDir:string);
    procedure DateTime2Int(strDT:String; var iM,iMday,iYr,iHr,iMin,iSec:integer);
    Procedure ClearAllKey;

    function FnExistInLinkList(Fn:string; head:Fileptr):boolean;
    function CountFilesInDir(Dir:string):word;
    procedure Refreshinterface;
  public
    { Public declarations }
    procedure DoTrayIconRightClick;
    Function GetIndex(head,tail,Pptr:Prjptr):integer;
  end;

var
  MainForm: TMainForm;
  MyNotifyStruct: TNotifyIconData; //NotifyIconData:]wuCϥܪƵc
  BufferBitmap, BackGroundBitmap,MenuUpBitmap,MenuOverBitmap, MenuDownBitmap,
  MinUpBitmap,MinOverBitmap, MinDownBitmap, CloseUpBitmap,CloseOverBitmap,CloseDownBitmap:TBitmap;
  MenuBmpRect,MinBmpRect,CloseBmpRect:TRect;
  AppDir,ReStoreDir:String;
  curPrj,prjhead,prjtail:Prjptr;
  fhead,ftail:Fileptr; //Source link list
  bhead,btail:Fileptr;
  ImageID:integer;
  SkinNum:Word;
  RandomSkin:byte; //0: no, 1:yes
  AutoBkUp:byte; //0: No,  1: Yes;
  TimelyChange,ShowComponents:boolean;
  TimelyChangePeriod:integer;
  KeyDn:Array[0..255] of boolean;
  lbxTargetListType:word;


implementation
uses AboutDlg;

{$R *.DFM}


var
  OldWindowProc : Pointer; {Variable for the old windows proc}
  MyMsg : DWord; {custom systemwide message}

function NewWindowProc(WindowHandle : hWnd;
                       TheMessage   : LongInt;
                       ParamW       : LongInt;
                       ParamL       : LongInt) : LongInt stdcall;
begin
  if TheMessage = MyMsg  then begin
   {Tell the application to restore, let it restore the form}
    SendMessage(Application.handle, WM_SYSCOMMAND, SC_RESTORE, 0);
    SetForegroundWindow(Application.Handle);
   {We handled the message - we are done}
    Result := 0;
    exit;
  end;
 {Call the original winproc}
  Result := CallWindowProc(OldWindowProc,
                           WindowHandle,
                           TheMessage,
                           ParamW,
                           ParamL);
end;


procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do
     Style := (Style or WS_POPUP) and (not WS_DLGFRAME)and (not WS_CAPTION) ;
end;


procedure TMainForm.WMNCHitTest(var Msg: TWMNCHitTest);
begin
  inherited;
  if  (Msg.Result = htClient) then
  with Msg do
  with ScreenToClient(Point(XPos,YPos)) do  //XPos,YPos: message Ǧ^y
  if (ptInRect(Rect(IConTop,IConTop,ClientWidth-IConTop,ClientHeight-IConTop),Point(X,Y))) then
  begin
    ShowBkgndPic(true);
    if not( PtInRect(MenuBmpRect, Point(X,Y)) or PtInRect(MinBmpRect, Point(X,Y)) or
         PtInRect(CloseBmpRect, Point(X,Y))) then
    begin
      if MenuImage.Picture.Bitmap<>MenuUpBitmap then MenuImage.Picture.Bitmap:=MenuUpBitmap;
      if MinImage.Picture.Bitmap<>MinUpBitmap then MinImage.Picture.Bitmap:=MinUpBitmap;
      if CloseImage.Picture.Bitmap<>CloseUpBitmap then CloseImage.Picture.Bitmap:=CloseUpBitmap;

      Result := htCaption;
    end;
  end
  else
  begin
    ShowBkgndPic(false);
    if not( PtInRect(MenuBmpRect, Point(X,Y)) or PtInRect(MinBmpRect, Point(X,Y)) or
         PtInRect(CloseBmpRect, Point(X,Y))) then
    begin
      if MenuImage.Picture.Bitmap<>MenuUpBitmap then MenuImage.Picture.Bitmap:=MenuUpBitmap;
      if MinImage.Picture.Bitmap<>MinUpBitmap then MinImage.Picture.Bitmap:=MinUpBitmap;
      if CloseImage.Picture.Bitmap<>CloseUpBitmap then CloseImage.Picture.Bitmap:=CloseUpBitmap;

      Result := htCaption;
    end;
  end;
end;


procedure TMainForm.WMTIMECHANGE(var Message: TWMTIMECHANGE);
begin
  ShowMessage('System Time Changed.');
end;





procedure TMainForm.BackUpFiles(head,tail:Fileptr; PrjDir:string);
var
  fptr:Fileptr;
  BkUpDir,PrjFn,strM,strD,strH:string;
  iY,iM,iD,iH,iMin,iSec,imSec:word;
begin
  DecodeDate(NOW,iY,iM,iD);
  DecodeTime(Now,iH,iMin,iSec,imSec);

  if (iM<10) then strM:=format('0%d',[iM])
  else strM:=format('%d',[iM]);

  if (iD<10) then strD:=format('0%d',[iD])
  else strD:=format('%d',[iD]);

  if (iH<10) then strH:=format('0%d',[iH])
  else strH:=format('%d',[iH]);

  BkUpDir:=PrjDir+'\'+strM+'_'+strD+'_'+strH;
  if not DirectoryExists(BkUpDir) then CreateDir(BkUpDir);
  fptr:=head;
  while (fptr<>nil) do
  begin
    //CopyFiles(fptr^.fn, TargetDir+'\'+ExtractFn_Add_DateTime(fptr^.fn));
    if FileExists(fptr^.fn) then
      CopyFiles(fptr^.fn, BkUpDir+'\'+ExtractFilename(fptr^.fn));
    fptr:=fptr^.next;
  end;

end;


procedure TMainForm.GetSourceFiles(PrjFn:string; var head, tail:Fileptr);
var
  F:TextFile;
  S:string;
  value,errcode:integer;
  frec:FileRec;
begin
   release_FileRec(head,tail);

   if FileExists(PrjFn) then
   begin
     AssignFile(F, PrjFn);   { File selected in dialog box }
     Reset(F);

     Repeat
       Readln(F,S);
       if FileExists(S) then
       begin
         frec.Fn:=S;
         frec.Checked:=true;
         frec.Delete:=false;
         Add_FileRec(head,tail,frec);
         //lbxSource.Items.Add(ExtractFileName(S));
       end;
     Until EOF(F);

     CloseFile(F);
   end;
end;


procedure TMainForm.ListBackUpDirs(PrjDir:String);
var
  sr,sr1: TSearchRec;
  FileCount,FileAttrs: Integer;
  Fname:string;
begin
  //Release_FileRec(bhead,btail);
  lbxTarget.clear;
  lbxTargetListType:=Folders;
  stTarget.Caption:='BackUp Folders';
  edTarget.Text:=PrjDir;

  FileAttrs :=$00000010 ;
  if FindFirst(PrjDir+'\*.*', FileAttrs, sr) = 0 then
  begin
     if (sr.attr=$00000010) and (sr.name<>'.') and (sr.name<>'..')  Then
      begin
          fileCount:=0;
          fName:=sr.Name;
          if FindFirst(PrjDir+'\'+fname+'\*.*', FileAttrs, sr1) = 0 then
           begin
            if ((sr1.attr=$00000020) or (sr1.attr=128)) and (sr1.name<>'.') and (sr1.name<>'..')  Then inc(FileCount);
           end;
           while (FindNext(sr1) = 0) and (fileCount=0) do
           begin
            if ((sr1.attr=$00000020) or (sr1.attr=128)) and (sr1.name<>'.') and (sr1.name<>'..') then inc(fileCount);
           end;
           FindClose(sr1);
        if fileCount>0 then lbxTarget.Items.Add(sr.name) else
        lbxTarget.Items.Add(sr.name);

      end;
      while FindNext(sr) = 0 do
      begin
        if (sr.attr=$00000010) and (sr.name<>'.') and (sr.name<>'..') 	then
        begin
        fileCount:=0;
          fName:=sr.Name;
          if FindFirst(PrjDir+'\'+fname+'\*.*', FileAttrs, sr1) = 0 then
           begin
            if ((sr1.attr=$00000020) or (sr1.attr=128)) and (sr1.name<>'.') and (sr1.name<>'..')  Then inc(FileCount);
           end;
           while (FindNext(sr1) = 0) and (fileCount=0) do
           begin
            if ((sr1.attr=$00000020) or (sr1.attr=128)) and (sr1.name<>'.') and (sr1.name<>'..') then inc(fileCount);
           end;
            FindClose(sr1);
           if fileCount>0 then lbxTarget.Items.Add(sr.name) else
          lbxTarget.Items.Add(sr.name);
        end;
      end;
      FindClose(sr);
  end;

  lbxTarget.Sorted:=true;
  lbxTarget.Sorted:=false;
  
end;


procedure TMainForm.ListBackUpFiles(head,tail:Fileptr);
var
  curf:Fileptr;
begin
  if head=nil then
  begin
    ShowMessage('No files exists.');
    exit;
  end;

  stTarget.Caption:='BackUp Files';
  lbxTargetListType:=Files; 
  lbxTarget.Clear;

  curf:=head;
  while curf<>nil do
  begin
    lbxTarget.Items.Add(ExtractFilename(curf^.fn));
    curf:=curf^.next;
  end;

end;


procedure TMainForm.FormCreate(Sender: TObject);
var
   myRgn : HRGN;
   round : integer;
   Fname : string;
begin
  {Register a custom windows message}
  MyMsg := RegisterWindowMessage('EzBkUp');
  {Set form1's windows proc to ours and remember the old window proc}
  OldWindowProc := Pointer(SetWindowLong(MainForm.Handle, GWL_WNDPROC, LongInt(@NewWindowProc)));


  TimelyChange:=true;
  ShowComponents:=true;
  TimelyChangePeriod:=30000; //30 second
  
  AppDir:=ExtractFileDir(ParamStr(0));
  if not DirectoryExists(AppDir+'\BkUp') then
     CreateDir(AppDir+'\BkUp');

  SkinNum:=CountFilesInDir(APPDir+'\Skin');
  ReadEzBkUp_Ini;

  if RandomSkin=0 then RandomSkin1.Checked:=false
  else RandomSkin1.Checked:=true;

  CurPrj:=prjhead;

  if RandomSkin=1 then
  begin
    randomize;
    ImageID:=random(SkinNum);
  end;

  FName:=AppDir+format('\Skin\EzBkUpSkin%d.bmp',[ImageID]);

  BackGroundBitmap := TBitmap.Create;

  //󴫮६
 //SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, PChar(FName), SPIF_SENDWININICHANGE);
  if fileexists(FName) then
    BackGroundBitmap.LoadFromFile(FName)
  else
    BackGroundBitmap.LoadFromResourceName(hInstance, 'BACKGROUND');
  BufferBitmap := TBitmap.Create;
  BufferBitmap.Width := BackGroundBitmap.Width;
  BufferBitmap.Height := BackGroundBitmap.Height;
  MainForm.ClientWidth := BackGroundBitmap.Width;
  MainForm.ClientHeight := BackGroundBitmap.Height;

  //s@ꨤ
  round :=200; //]wFormꨤb|
  MainForm.Brush.Style:=bsClear;
  myRgn := 0;
  GetWindowRgn(MainForm.Handle, myRgn);//oformܽdëwmyRgn
  DeleteObject(myRgn); //RmyRgnWҦ
  myRgn:= CreateroundRectRgn(0,0,MainForm.Width,MainForm.Height, round, round);//إ߶ꨤ|άd
  SetWindowRgn(MainForm.Handle, myRgn, TRUE); //Nform region]myrgnAó]redrawtrue;
  BitBlt(BufferBitmap.Canvas.Handle, 0, 0, BufferBitmap.Width, BufferBitmap.Height,
            BackGroundBitmap.Canvas.Handle, 0, 0, SRCCOPY);

  //Menu
  With MenuBmpRect do
  begin
    left:=MenuImage.left;
    top:=MenuImage.top;
    Right:=left+32;
    Bottom:=top+32;
  end;
  MenuImage.Width := 32;
  MenuImage.Height := 32;
  //MenuImage.Top := MenuBmpRect.top;
  //MenuImage.Left := MenuBmpRect.left;
  MenuUPBitmap := TBitmap.Create;
  MenuUPBitmap.LoadFromResourceName(hInstance, 'MENUUP');
  MenuOverBitmap := TBitmap.Create;
  MenuOverBitmap.LoadFromResourceName(hInstance, 'MENUOVER');
  MenuDOWNBitmap := TBitmap.Create;
  MenuDOWNBitmap.LoadFromResourceName(hInstance, 'MENUDOWN');
  MenuImage.Picture.Bitmap := MenuUPBitmap;


  //Ypƪ
  with MinBmpRect do
  begin
    left:=MinImage.left;
    top:=MinImage.top;
    Right:=left+32;
    Bottom:=top+32;
  end;
  MinImage.Width := 32;
  MinImage.Height := 32;
  //MinImage.Top := MinBmpRect.top;
  //MinImage.Left := MinBmpRect.left;
  MinUPBitmap := TBitmap.Create;
  MinUPBitmap.LoadFromResourceName(hInstance, 'MINUP');
  MinOverBitmap := TBitmap.Create;
  MinOverBitmap.LoadFromResourceName(hInstance, 'MINOVER');
  MinDOWNBitmap := TBitmap.Create;
  MinDOWNBitmap.LoadFromResourceName(hInstance, 'MINDOWN');
  MinImage.Picture.Bitmap := MinUPBitmap;

  //}{
  with CloseBmpRect do
  begin
    left:=CloseImage.left;
    top:=CloseImage.top;
    Right:=left+32;
    Bottom:=top+32;
  end;
  CloseImage.Width :=32;
  CloseImage.Height := 32;
  //CloseImage.Top := CloseBmpRect.top;
  //CloseImage.Left := CloseBmpRect.left;
  CloseUPBitmap := TBitmap.Create;
  CloseUPBitmap.LoadFromResourceName(hInstance, 'CLOSEUP');
  CloseOVERBitmap := TBitmap.Create;
  CloseOverBitmap.LoadFromResourceName(hInstance, 'CLOSEOVER');
  CloseDOWNBitmap := TBitmap.Create;
  CloseDOWNBitmap.LoadFromResourceName(hInstance, 'CLOSEDOWN');
  CloseImage.Picture.Bitmap := CloseUPBitmap;


  //إTrayIcon
  with MyNotifyStruct do  //wuCWIconƤeӷPƹʨöǥXT
  begin
    cbSize := sizeof(MyNotifyStruct);//NotifyIconDatajpANotifyIconDataWindows API
    Wnd := MainForm.handle; //ΨӱIconҶǻTFormHandle
    uID := 1;
    uFlags :=  NIF_ICON or NIF_TIP or NIF_MESSAGE;
    hIcon := LoadIcon(hInstance, 'TRAYICON'); //q귽ɨoIconHandleëwhIcon
    szTip := 'Auto-BackUp!';
    uCallBackMessage := WM_Userdef; //NT]Const ۦwqT~ WM_Userdef
  end;
  Shell_NotifyIcon(NIM_ADD, @MyNotifyStruct); //NۦwqnTƥ[tΤ


  if  AutoBkUp=0 then
  if MessageDlg(format('Hi, %s. Do you wanna enable Auto BackUp?',[GetCurrentUserName]), mtConfirmation,
     [mbYes, mbNo], 0) = mrYes then
  begin
    AutoBkUp:=1;
  end;

  case AutoBkUp of
  0:
   begin
     tbtnStop.Down:=true;
     tbtnStopRunClick(tbtnStop);
   end;
  1:
   begin
     tbtnRun.Down:=true;
     tbtnStopRunClick(tbtnRun);
   end;
  end;    
end;



procedure TMainForm.IconCallBackMessage( var Msg : TMessage );
begin
  case Msg.lParam of
  WM_LBUTTONDBLCLK :
    begin
      SetForegroundWindow( Application.Handle );
      Application.ProcessMessages;
      MainForm.Visible:=true;
    end;
  WM_RBUTTONDOWN   : DoTrayIconRightClick;
  WM_LBUTTONDOWN   :
    if MainForm.Visible then
    begin
      SetForegroundWindow( Application.Handle );
      Application.ProcessMessages;
    end;
  end;
end;

procedure TMainForm.DoTrayIconRightClick;
var
   MouseCo: Tpoint;
begin
   GetCursorPos(MouseCo);
   SetForegroundWindow( Application.Handle );
   Application.ProcessMessages;
   RatMenu.Popup( Mouseco.X, Mouseco.Y );
end;



procedure TMainForm.RatMenuPopup(Sender: TObject);
begin
  if MainForm.Visible = TRUE then
     cmHide.Caption := 'H&ide'
  else
     cmHide.Caption := '&Show';   
end;

procedure TMainForm.Hide1Click(Sender: TObject);
begin
  MainForm.Visible:=false;
end;

procedure TMainForm.cmQuitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.cmHideClick(Sender: TObject);
begin
  if cmHide.Caption = '&Show' then
    MainForm.Show
  else
    MainForm.Hide;
end;


Function TMainForm.FnExistInLinkList(Fn:String; head:Fileptr):boolean;
var
  fptr:Fileptr;
begin
  result:=false;
  fptr:=fhead;
  while (fptr<>nil) do
  begin
    if (Fn=fptr^.Fn) then
    begin
      result:=true;
      exit;
    end;
    fptr:=fptr^.next;
  end;
end;

procedure TMainForm.btnAddClick(Sender: TObject);
var
  i:integer;
  strFn:string;
  frec:FileRec;
begin
  if DirectoryExists(RestoreDir) then OpDlg1.InitialDir:=ReStoreDir;
  if OpDlg1.Execute then
  begin
    ReStoreDir:=ExtractFileDir(Opdlg1.Files.Strings[0]);
    with opdlg1.Files do
    for i := 0 to Count - 1 do
    begin
      strFn:=Strings[i];
      if (not FnExistInLinkList(strFn, fhead)) then
      begin
        frec.Fn:=strFn;
        frec.Checked:=true;
        frec.Delete:=false;
        Add_FileRec(fhead,ftail,frec);
      end;  
    end;
  end;

  WritePrj_Ini(curPrj^.prjTgtDir+'\Project.ini');
  
  ListSourceFiles(fhead,ftail);
end;

procedure TMainForm.FormPaint(Sender: TObject);
begin
  ShowWindow (Application.Handle, SW_HIDE); //SW_HIDE:Hides the window and activates another window.
  BitBlt(BufferBitmap.Canvas.Handle, 0, 0, BufferBitmap.Width, BufferBitmap.Height,
      BackGroundBitmap.Canvas.Handle, 0, 0, SRCCOPY);

  bitblt(mainform.canvas.handle,0,0,bufferbitmap.width,bufferbitmap.height,bufferbitmap.canvas.handle,0,0,srccopy);
  MinImage.Refresh;
  CloseImage.Refresh;
  MenuImage.Refresh; 
end;

procedure TMainForm.MinImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  MinImage.Picture.Bitmap := MinUPBitmap;
end;

procedure TMainForm.MinImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  MinImage.Picture.Bitmap := MinDOWNBitmap;
end;

procedure TMainForm.MinImageClick(Sender: TObject);
begin
  MainForm.Hide;
end;

procedure TMainForm.CloseImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin 
  CloseImage.Picture.Bitmap := CloseUPBitmap;
end;

procedure TMainForm.CloseImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  CloseImage.Picture.Bitmap := CloseDownBitmap;
end;

procedure TMainForm.CloseImageClick(Sender: TObject);
begin
  close;
end;

procedure TMainForm.MenuImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  MenuImage.Picture.Bitmap := MenuUPBitmap;
end;

procedure TMainForm.MenuImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MenuImage.Picture.Bitmap := MenuDownBitmap;
end;

procedure TMainForm.btnselDirClick(Sender: TObject);
var
  strTarget:string;
const
  SELDIRHELP = 1000;
begin
  if MessageDlg(format('Change %s BackUp Directory?',[curPrj^.prjName]), mtConfirmation,
     [mbYes, mbNo], 0) = mrNo then exit;

  strTarget:=curPrj^.prjTgtDir;
  if SelectDirectory(strTarget, [sdAllowCreate, sdPerformCreate, sdPrompt],SELDIRHELP) then
  begin
    edTarget.text:=strTarget;
    curPrj^.prjTgtDir:=strTarget;
    ListBackUpDirs(curPrj^.prjTgtDir);
  end;     
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if MessageDlg('Are you sure to exit this program?', mtConfirmation,
     [mbYes, mbNo], 0) = mrNo then CanClose:=false
  else CanClose:=true;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  BufferBitmap.Free;
  BackGroundBitmap.Free;
  MenuUpBitmap.Free;
  MenuDownBitmap.Free;
  MinUpBitmap.Free;
  MinDownBitmap.Free;
  CloseUpBitmap.Free;
  CloseDownBitmap.Free;

  {Set form1's window proc back to it's original procedure}
  SetWindowLong(MainForm.Handle, GWL_WNDPROC, LongInt(OldWindowProc));
end;

procedure TMainForm.ReadEzBkUp_Ini;
var
  IniF,S:string;
  F:TextFile;
  pRec:PrjRec;
  curP:Prjptr;
  value,errcode:integer;
begin
  IniF:=AppDir+'\EzBkUp.ini';

  if FileExists(IniF) then
  begin
   AssignFile(F, IniF);   { File selected in dialog box }
   Reset(F);

   Readln(F, S);
   val(s,value,errcode);
   if errcode=0 then RandomSkin:=value
   else RandomSkin:=1;

   Readln(F, S);
   val(s,value,errcode);
   if errcode=0 then ImageId:=value
   else ImageId:=-1;

   Readln(F, S);
   val(s,value,errcode);
   if errcode=0 then AutoBkUp:=value
   else AutoBkUp:=1;

   Readln(F,S);
   Readln(F,S);
   Readln(F,S);

   repeat
     with pRec do
     begin
       Readln(F, prjName);
       Readln(F, prjTgtDir);

       Readln(F, S);
       val(s,value,errcode);
       if errcode=0 then blRun:=value
       else blRun:=1;

       Readln(F, S);
       val(s,value,errcode);
       if (errcode=0) and (value<4) then prjBackUpType:=value
       else prjBackUpType:=0;

       Readln(F, S);
       val(s,value,errcode);
       if (errcode=0) and (value<31) then prjBackUpDay:=value
       else prjBackUpDay:=1;

       Readln(F, S);
       val(s,value,errcode);
       if (errcode=0) and (value<24) then prjBackUpTime:=value
       else prjBackUpTime:=1;

       if FileExists(prjTgtDir+'\'+'Project.ini') then
       Add_PrjRec(Prjhead,Prjtail,pRec);
     end;
   until EOF(F);

   CloseFile(F);
  end
  else
  begin
   Randomskin:=1;
   ImageID:=-1;
   AutoBkUp:=0;
  end;

  if prjhead=nil then
  with pRec do
  begin
    prjName:='MyPrj-1';
    if not DirectoryExists(AppDir+'\BkUp') then
      createDir(AppDir+'\BkUp');
    prjTgtDir:=AppDir+'\BkUp';
    blRun:=1;
    prjBackUpType:=0;
    prjBackUpDay:=1;
    prjBackUpTime:=10; 
    Add_PrjRec(Prjhead,Prjtail,pRec);
  end;     

end;


procedure TMainForm.WriteEzBkUp_Ini;
var
  F: TextFile;
  Fn:String;
  curP:Prjptr;
begin
  Fn:=AppDir+'\EzBkUp.ini';

  AssignFile(F, Fn);
  ReWrite(F);

  Writeln(F, format('%d',[RandomSkin]));
  Writeln(F, format('%d',[ImageId]));
  Writeln(F, format('%d',[AutoBkUp]));
  Writeln(F, 'Reserve 1');
  Writeln(F, 'Reserve 2');
  Writeln(F, 'Reserve 3');

  curP:=Prjhead;
  while curP<>nil do
  with curP^ do
  begin
    Writeln(F, PrjName);
    Writeln(F, PrjTgtDir);
    Writeln(F, format('%d',[blRun]));
    Writeln(F, format('%d',[prjBackUpType]));
    Writeln(F, format('%d',[prjBackUpDay]));
    Writeln(F, format('%d',[prjBackUpTime]));

    curP:=curP^.next;
  end;

  CloseFile(F);
end;

procedure TMainForm.WritePrj_Ini(PrjFn:String);
var
  F: TextFile;
  fptr:Fileptr;
begin
  AssignFile(F, PrjFn);
  ReWrite(F);

  fptr:=fhead;
  while (fptr<>nil) do
  begin
    Writeln(F, fptr^.Fn);
    fptr:=fptr^.next;
  end;

  CloseFile(F);
end;


procedure TMainForm.ListProjects;
var
  curP:Prjptr;
begin
  cbxProjects.Clear;
  curP:=Prjhead;
  while curP<>nil do
  begin
    cbxProjects.Items.Add(curP^.prjName);
    curP:=curP^.next;
  end;
end;


procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  PrjFn:String;
  fptr:Fileptr;
begin
  WriteEzBkUp_Ini;

  //if MessageDlg('Do you want to save current project?', mtConfirmation,[mbYes, mbNo], 0) = mrYes then
  prjFn:=curPrj^.prjTgtDir+'\Project.ini';
  writePrj_ini(prjFn);

  release_FileRec(fhead,ftail);
  release_FileRec(bhead,btail);//BackUP filse link
  release_PrjRec(Prjhead,Prjtail);
end;


Function TMainForm.GetIndex(head,tail,Pptr:Prjptr):integer;
var
  curP:PrjPtr;
  i:integer;
  GetMatched:boolean;
begin
  GetMatched:=false;

  i:=0;
  curP:=head;
  while curP<>nil do
  begin
    if curP=Pptr then
    begin
      result:=i;
      GetMatched:=true;
      exit;
    end;
    inc(i);
    curP:=curP^.next;
  end;

  if not GetMatched then result:=-1;

end;

procedure TMainForm.Refreshinterface;
var
  i:integer;
  curP:Prjptr;
  curf:Fileptr;
const
  BkUpAry:Array[0..1]of string=('Auto BackUp Off','Auto BackUp On');
begin
  //if curPrj=nil then exit;

  //cbxProjects.ItemIndex:=GetIndex(Prjhead,Prjtail,curPrj);
  //if cbxProjects.ItemIndex<0 then exit;

  with curPrj^ do
  begin
    // lbxSource
    GetSourceFiles(prjTgtDir+'\Project.ini',fhead,ftail);
    ListSourceFiles(fhead,ftail);
    edBkUp.Text:=BkUpAry[blRun];

    // lbxTarget
    ListBackUpDirs(prjTgtDir);
    edTarget.Text:=prjTgtDir;

    // AutoBackup Panel
    cbxBkUpType.ItemIndex:=prjBackUpType;
    cbxBkupTypeChange(cbxBkupType);
    cbxTime.ItemIndex:=prjBackUpTime;
  end;
end;

procedure TMainForm.OpenProject1Click(Sender: TObject);
var
  strTarget:string;
  Fn:string;
  i:integer;
  curP:Prjptr;
begin
  Application.CreateForm(TPrjDlg,PrjDlg);
  PrjDlg.ShowModal;
  PrjDlg.Free;

  ListProjects;
  cbxProjects.ItemIndex:=GetIndex(prjhead,prjtail,curPrj);
  RefreshInterface;
end;

procedure TMainForm.btnRestoreClick(Sender: TObject);
var
  strTarget,ToFn,BackUpName:string;
  fptr:Fileptr;
  i:integer;
  iSel:word;
  selItem:boolean;
const
  SELDIRHELP = 1000;
begin
  if lbxTargetListType=Folders then
  begin
    ShowMessage('Please double click a Folder to enter and select Restore Files.');
    exit;
  end;

  selItem:=false;
  isel:=0;

  with lbxTarget.Items do
  for i:=0 to Count-1 do
  if lbxtarget.Selected[i] then
  begin
    selItem:=true;
    inc(isel);
  end;

  if not selItem then
  begin
    ShowMessage('No File selected.');
    exit;
  end;

  strTarget:=ReStoreDir;
  if MessageDlg(format('Are you sure to restore selected %d files?',[isel]), mtConfirmation,
     [mbYes, mbNo], 0) = mrNo then exit;

  if SelectDirectory(strTarget, [sdAllowCreate, sdPerformCreate, sdPrompt],SELDIRHELP) then
  begin
    if MessageDlg(format('Restore to %s? This will overwrite exist files, if there are.',[strTarget]),
       mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit;

    Screen.Cursor:=crHourGlass;

    lbStatus.Caption:='Restore Files Now...';
    lbStatus.Refresh;

    RestoreDir:=strTarget;
    //Resotre selected files in lbxTarget

    i:=0;
    fptr:=bhead;
    while (fptr<>nil) do
    begin
      if lbxTarget.Selected[i] then
      begin
        ToFn:=RestoreDir+'\'+ExtractFileName(fptr^.fn);
        if FileExists(ToFn) then  //ƥɮ
        begin
          BackupName := ExtractFileName(ToFn);
          BackupName := ChangeFileExt(BackupName, '.BAK');
          if not RenameFile(ToFn, BackupName) then
            raise Exception.Create('Unable to create backup file.');
        end;
        CopyFiles(fptr^.fn,ToFn);
      end;
      inc(i);
      fptr:=fptr^.next;
    end;

    Screen.Cursor:=crdefault;

    ShowMessage('Restore Success.');

    lbStatus.Caption:='';
  end;
end;

procedure TMainForm.ListSourceFiles(head,tail:Fileptr);
var
  fptr:Fileptr;
begin
  lbxSource.clear;

  fptr:=head;

  while (fptr<>nil) do
  begin
    lbxSource.Items.Add(ExtractFileName(fptr^.fn));
    fptr:=fptr^.next;
  end;
end;

procedure TMainForm.btnDeleteClick(Sender: TObject);
var
  i:integer;
  fptr:Fileptr;
begin
  fptr:=fhead;
  
  i:=0;
  fptr:=fhead;
  while fptr<>nil do
  begin
    if lbxSource.Selected[i] then fptr^.Delete:=true
    else fptr^.Delete:=false;
    inc(i);
    fptr:=fptr^.next;
  end;

  fptr:=fhead;
  while fptr<>nil do
  begin
    if fptr^.Delete then
    begin
      if fptr=fhead then
      begin
        Delete_FileRec(fhead,ftail,fptr);
        fptr:=fhead;
      end
      else
      begin
        fptr:=fptr^.prior;
        Delete_FileRec(fhead,ftail,fptr^.next);
        fptr:=fptr^.next;
      end;
    end
    else
      fptr:=fptr^.next;
  end;

  WritePrj_Ini(curPrj^.prjTgtDir+'\Project.ini');
  
  ListSourceFiles(fhead,ftail);
end;





procedure TMainForm.GetBackUpFiles(BkUpDir:string; var head,tail:Fileptr);
var
  DirInfo: TSearchRec;
  r: Integer;
  frec:FileRec;
begin
  release_FileRec(head,tail);

  if not DirectoryExists(BkUpDir) then exit;

  r := FindFirst(BkUpDir+'\*.*', FaAnyfile, DirInfo);
  while r = 0 do
  begin
    if ((DirInfo.Attr and FaDirectory <> FaDirectory) and
        (DirInfo.Attr and FaVolumeId <> FaVolumeID)) then
    //if DirInfo.Name<>'Project.ini' then
    begin
      frec.Fn:=BkUpDir+'\'+DirInfo.Name;
      frec.Checked:=true;
      frec.Delete:=false;
      Add_FileRec(head,tail,frec);
    end;
      r := FindNext(DirInfo);
  end;

  SysUtils.FindClose(DirInfo);
end;


function TMainForm.CountFilesInDir(Dir:string):word;
var
  DirInfo: TSearchRec;
  r: Integer;
  fn:string;
begin
  result:=0;
  
  if not DirectoryExists(Dir) then exit;

  r := FindFirst(Dir+'\*.*', FaAnyfile, DirInfo);
  while r = 0 do
  begin
    if ((DirInfo.Attr and FaDirectory <> FaDirectory) and
        (DirInfo.Attr and FaVolumeId <> FaVolumeID)) then
    begin
      inc(result);
    end;
    r := FindNext(DirInfo);
  end;

  SysUtils.FindClose(DirInfo);
end;

procedure TMainForm.BtnDelBkUpClick(Sender: TObject);
var
  i,isel:integer;
  fptr:Fileptr;
  selItem:boolean;
  BkUpDir,fnames:string;
const
  ListTp:Array[0..1] of string=('Folder','File');  
begin
  selItem:=false;
  isel:=0;

  with lbxTarget.Items do
  for i:=0 to Count-1 do
  if lbxtarget.Selected[i] then
  begin
    selItem:=true;
    inc(isel);
  end;

  if not selItem then
  begin
    ShowMessage(format('No %s selected.',[ListTp[lbxTargetListType]]));
    exit;
  end;

  if MessageDlg(format('Are you sure to delete selected %d %s?',[isel,ListTp[lbxTargetListType]]),
                mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit;

  case lbxTargetListType of
  Folders:
    with lbxTarget do
    begin
      for i:=0 to Items.Count-1 do
      if selected[i] then
      begin
        BkUpDir:=curPrj^.prjTgtDir+'\'+Items[i];

        GetBackUpFiles(BkUpDir, bhead,btail);

        fnames:='';
        fptr:=bhead;
        while fptr<>nil do
        begin
          if fptr=bhead then
          begin
            DeleteFile(fptr^.fn);  //Rɮ
            //RecycleFile(fptr^.fn);   //Nɮײ귽^

            Delete_FileRec(bhead,btail,fptr);
            fptr:=bhead;
          end
          else
          begin
            fptr:=fptr^.prior;
            DeleteFile(fptr^.next^.fn);
            //RecycleFile(fptr^.next^.fn);
            Delete_FileRec(bhead,btail,fptr^.next);
            fptr:=fptr^.next;
          end;
        end;
        RemoveDir(BkUpDir);
      end;

      ListBackUpDirs(curPrj^.prjTgtDir+'\');
    end;
  Files:
    begin
      i:=0;
      fptr:=bhead;
      while fptr<>nil do
      begin
        if lbxTarget.Selected[i] then fptr^.Delete:=true
        else fptr^.Delete:=false;

        inc(i);
        fptr:=fptr^.next;
      end;

      fptr:=bhead;
      while fptr<>nil do
      begin
        if fptr^.Delete then
        begin
          if fptr=bhead then
          begin
            DeleteFile(fptr^.fn);
            //RecycleFile(fptr^.fn);
            Delete_FileRec(bhead,btail,fptr);
            fptr:=bhead;
          end
          else
          begin
            fptr:=fptr^.prior;
            DeleteFile(fptr^.next^.fn);
            //RecycleFile(fptr^.next^.fn);
            Delete_FileRec(bhead,btail,fptr^.next);
            fptr:=fptr^.next;
          end;
        end
        else
          fptr:=fptr^.next;
      end;
      ListBackUpFiles(bhead,btail);
    end;
  end;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  close;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  Application.CreateForm(TAboutBox,AboutBox);
  //MakeRoundedWindow(AboutBox,150);
  AboutBox.lbVer.Caption:='Ver: 1.0a';
  AboutBox.ShowModal;
  AboutBox.Free;
end;

procedure TMainForm.btnBackUpClick(Sender: TObject);
begin
  if fhead=nil then
  begin
    ShowMessage('Please select Source Files first');
    exit;
  end;
  
  screen.Cursor:=crhourGlass;
  lbStatus.Caption:='BackUp Files Now...';
  lbStatus.Refresh;
  BackUPFiles(fhead,ftail,curPrj^.prjTgtDir);
  lbStatus.Caption:='';
  ListBackUpDirs(curPrj^.prjTgtDir);
  screen.Cursor:=crdefault;
  ShowMessage('BackUP Success.');

  if lbxTarget.Visible then lbxTarget.SetFocus;
end;

procedure TMainForm.cbxBkupTypeChange(Sender: TObject);
var
  i:integer;
begin

  with cbxBkUpType do
  case ItemIndex of
  0:   //hourly
    begin
      cbxDay.Enabled:=false;
      cbxTime.Enabled:=false;
    end;
  1: //daily
    begin
      cbxDay.Enabled:=false;
      cbxTime.Enabled:=true;
      cbxTime.ItemIndex:=curPrj^.prjBackUpTime; //0:00 ~ 23:00
    end;
  2: //weekly;
    begin
      cbxDay.Enabled:=true;
      cbxTime.Enabled:=true;
      cbxDay.Clear;
      for i:=0 to 6 do cbxDay.Items.Add(WeekDay[i+1]);
      cbxDay.ItemIndex:=curPrj^.prjBackUpDay mod 7;
      cbxDayChange(cbxDay);
    end;
  3://monthly;
    begin
      cbxDay.Enabled:=true;
      cbxTime.Enabled:=true;
      cbxDay.Clear;
      for i:=1 to 31 do cbxDay.Items.Add(format('Day %2d',[i]));
      cbxDay.ItemIndex:=curPrj^.prjBackUpDay;
      cbxDayChange(cbxDay);
    end;
  end;

  //if curPrj<>nil then  curPrj^.prjBackUpType:=cbxBkUpType.ItemIndex;
end;



procedure TMainForm.FormShow(Sender: TObject);
begin
  cbxBkUpType.ItemIndex:=curPrj^.prjBackUpType;
  //cbxBkupTypeChange(Sender);
  if btnBackUp.Visible then btnBackUp.SetFocus;

  ListProjects;
  //GetSourceFiles(curPrj^.prjTgtDir+'\Project.ini',fhead,ftail);
  cbxProjects.ItemIndex:=GetIndex(prjhead,prjtail,curPrj);
  Refreshinterface;
end;

procedure TMainForm.RandomSkin1Click(Sender: TObject);
begin
  RandomSkin1.Checked:=not RandomSkin1.Checked;
  RandomSkin:=(RandomSkin+1) mod 2
end;

procedure TMainForm.ChangeSkin1Click(Sender: TObject);
var
  Fname:string;
begin
  if SkinNum=0 then exit;
  repeat
    ImageId:=(ImageId+1) mod SkinNum; 
    FName:=AppDir+format('\Skin\EzBkUpSkin%d.bmp',[ImageID]);
  until FileExists(FName);
  
  if FileExists(FName) then
  begin
    BackGroundBitmap.LoadFromFile(FName);
    FormPaint(Sender);
  end;
end;    


procedure TMainForm.MenuImageMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  MenuImage.Picture.Bitmap:=MenuOverBitmap;
end;

procedure TMainForm.MinImageMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  MinImage.Picture.Bitmap:=MinOverBitmap
end;

procedure TMainForm.CloseImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  CloseImage.Picture.Bitmap:=CloseOverBitmap
end;

procedure TMainForm.tbtnStopRunClick(Sender: TObject);
begin
  if Sender=tbtnStop then
  begin
    AutoBkUp:=0;
    lblAutoBkUp.Font.Color:=$7d7dff;
    lblAutoBkUp.Caption:='Timer BkUp Disabled';
  end
  else if Sender=tbtnRun then
  begin
    AutoBkUp:=1;
    lblAutoBkUp.Font.Color:=$7dff7d;
    lblAutoBkUp.Caption:='Timer BkUp Enabled';
  end;
end;

procedure TMainForm.Transparent1Click(Sender: TObject);
begin
  MakeWindowTransparent(MainForm);
end;

procedure TMainForm.Opaque1Click(Sender: TObject);
begin
  MakeWindowOpaque(MainForm);
end;

procedure TMainForm.btnSetTimeClick(Sender: TObject);
begin
  if cbxBkUpType.ItemIndex>=0 then curPrj^.prjBackUpType:=cbxBkUpType.ItemIndex
  else curPrj^.prjBackUpType:=0;

  if cbxDay.ItemIndex>=0 then curPrj^.prjBackUpDay:=cbxDay.ItemIndex
  else curPrj^.prjBackUpDay:=1;

  if cbxTime.ItemIndex>=0 then curPrj^.prjBackUpTime:=cbxTime.ItemIndex
  else  curPrj^.prjBackUpTime:=10;

  WriteEzBkUp_Ini;  
end;

procedure TMainForm.cbxDayChange(Sender: TObject);
begin
  cbxDay.Text:=cbxDay.Items[cbxDay.ItemIndex];
  curPrj^.prjBackUpDay:=cbxDay.ItemIndex;
end;


procedure TMainForm.DateTime2Int(strDT:String; var iM,iMday,iYr,iHr,iMin,iSec:integer);
var
  lstr,iId:integer;
  IsAM:boolean;
begin
  //Get Month, Date, Year, Hour, Minute, Second
  lstr:=Length(strDT);
  iId:=Pos('/',strDT);

  if iId>3 then //    2001/3/23 style
  begin
    iYr:=StrToInt(copy(strDT,1,iId-1));
    strDT:=copy(StrDT,iId+1, lstr-iId);

    lstr:=Length(strDT);
    iId:=Pos('/',strDT);
    iM:=StrToInt(copy(strDT,1,iId-1));
    strDT:=copy(StrDT,iId+1, lstr-iId);

    lstr:=Length(strDT);
    iId:=Pos(' ',strDT);
    iMday:=StrToInt(copy(strDT,1,iId-1));
    strDT:=copy(StrDT,iId+1, lstr-iId);
  end
  else     //   3/23/2001 style
  begin
    iM:=StrToInt(copy(strDT,1,iId-1));
    strDT:=copy(StrDT,iId+1, lstr-iId);

    lstr:=Length(strDT);
    iId:=Pos('/',strDT);
    iMday:=StrToInt(copy(strDT,1,iId-1));
    strDT:=copy(StrDT,iId+1, lstr-iId);

    lstr:=Length(strDT);
    iId:=Pos(' ',strDT);
    iYr:=StrToInt(copy(strDT,1,iId-1));
    strDT:=copy(StrDT,iId+1, lstr-iId);
  end;

  if strDt[1]<>#164 then //O
  begin
    lstr:=Length(strDT);
    iId:=Pos(':',strDT);
    iHr:=StrToInt(copy(strDT,1,iId-1));
    strDT:=copy(StrDT,iId+1, lstr-iId);

    lstr:=Length(strDT);
    iId:=Pos(':',strDT);
    iMin:=StrToInt(copy(strDT,1,iId-1));
    strDT:=copy(StrDT,iId+1, lstr-iId);

    lstr:=Length(strDT);
    iId:=Pos(' ',strDT);
    iSec:=StrToInt(copy(strDT,1,iId-1));
    strDT:=copy(StrDT,iId+1, lstr-iId);

    if strDT='AM' then
      iHr:=iHr
    else iHr:=iHr+12;
  end
  else //O
  begin
    if strDt[2]='W' then //W
      IsAM:=true
    else IsAM:=false;

    lstr:=Length(strDT);
    iId:=Pos(' ',strDT);
    strDT:=copy(StrDT,iId+1, lstr-iId);
    
    lstr:=Length(strDT);
    iId:=Pos(':',strDT);
    iHr:=StrToInt(copy(strDT,1,iId-1));
    strDT:=copy(StrDT,iId+1, lstr-iId);

    lstr:=Length(strDT);
    iId:=Pos(':',strDT);
    iMin:=StrToInt(copy(strDT,1,iId-1));
    strDT:=copy(StrDT,iId+1, lstr-iId);

    iSec:=StrToInt(strDT);   

    if IsAM then
      iHr:=iHr
    else iHr:=iHr+12;
  end;  

end;

procedure TMainForm.Timer1Timer(Sender: TObject);
var
  i:integer;
  iWeekday,iYear,iMonth,iMonthday,iHour,iMinute,isecond,imsec:word;
  strTime:String;
  curP:Prjptr;
  tmpfhead,tmpftail:Fileptr;
  DoBackUp:boolean;
begin
  if TimelyChange then
  if ((gettickcount mod TimelyChangePeriod)<1000) then ChangeSkin1Click(Sender);

  //lblClock.Caption:=DateToStr(Date)+'  --  '+TimeToStr(Time);
  iWeekday:=DayOfWeek(Now);
  strTime:=DateTimeToStr(Now);
  lblClock.Caption:=strTime+'  --  '+WeekDay[iWeekday];

  if AutoBkUp=1 then //pGҰʦ۰ʳƥ
  begin
    //DateTime2Int(strTime, iMonth,iMonthday,iYear,iHour,iMinute,iSecond);
    DecodeDate(Now,iYear,iMonth,iMonthday);
    DecodeTime(Now,iHour,iMinute,iSecond,imSec);

    tmpfhead:=nil;
    tmpftail:=nil;
    DoBackUP:=false;

    curP:=Prjhead;
    while curP<>nil do
    begin
      with curP^ do
      if blRun=1 then
      Case prjBackUpType of
      0: //hourly
       if (iMinute=0) and ((iSecond mod 60)<iSecTolerance) then
       begin
         lbStatus.Caption:=format('Hourly Auto BackUp Project %s Files Now...',[prjName]);
         lbStatus.Refresh;
         GetSourceFiles(prjTgtDir+'\Project.ini',tmpfhead,tmpftail);
         BackUPFiles(tmpfhead,tmpftail,prjTgtDir);
         lbStatus.Caption:='';
         DoBackUp:=true;
       end;
      1: //daily
       if (iHour=prjBackUpTime) and (iMinute=0) and ((iSecond mod 60)<iSecTolerance) then
       begin
         lbStatus.Caption:=format('Daily Auto BackUp Project %s Files Now...',[prjName]);
         lbStatus.Refresh;
         GetSourceFiles(prjTgtDir+'\Project.ini',tmpfhead,tmpftail);
         BackUPFiles(tmpfhead,tmpftail,prjTgtDir);
         lbStatus.Caption:='';
         DoBackUp:=true;
       end;
      2: //weekly
       if (iWeekday=prjBackUpDay+1) and (iHour=prjBackUpTime) and (iMinute=0) and ((iSecond mod 60)<iSecTolerance) then
       begin
         lbStatus.Caption:=format('Weekly Auto BackUp Project %s Files Now...',[prjName]);
         lbStatus.Refresh;
         GetSourceFiles(prjTgtDir+'\Project.ini',tmpfhead,tmpftail);
         BackUPFiles(tmpfhead,tmpftail,prjTgtDir);
         lbStatus.Caption:='';
         DoBackUp:=true;
       end;
      3: //monthly
       if (iMonthday=prjBackUpDay+1) and (iHour=prjBackUpTime) and (iMinute=0) and ((iSecond mod 60)<iSecTolerance) then
       begin
         lbStatus.Caption:=format('Monthly Auto BackUp Project %s Files Now...',[prjName]);
         lbStatus.Refresh;
         GetSourceFiles(prjTgtDir+'\Project.ini',tmpfhead,tmpftail);
         BackUPFiles(tmpfhead,tmpftail,prjTgtDir);
         lbStatus.Caption:='';
         DoBackUp:=true;
       end;
      end;

      curP:=curP^.next;
    end;

    if DoBackUP then RefreshInterface;
  end;
end;

procedure TMainForm.cbxTimeChange(Sender: TObject);
begin
  curPrj^.prjBackUpTime:=cbxTime.ItemIndex;
end;

Procedure TMainForm.ClearAllKey;
var
  i:integer;
begin
  for i:=0 to 255 do KeyDn[i]:=false;
end;

procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=16) then KeyDn[16]:=false;

  if (Key=17) then
  begin
    KeyDn[17]:=false;
    if (not KeyDn[17]) then ClearAllKey();
  end;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=17) then KeyDn[17]:=true;
  if (Key=16) then KeyDn[16]:=true;

  if (KeyDn[17]) then
  begin
    KeyDn[Key]:=true;

    if (KeyDn[67]) then //C: Change Skin
    begin
      //ClearAllKey();
      ChangeSkin1Click(Sender);
      KeyDn[67]:=not KeyDn[67];
    end;

    if (KeyDn[69] and KeyDn[65] and KeyDn[83] and KeyDn[84] and KeyDn[75] )  then//eastek : show aboutdlg
    begin
      ClearAllKey();
      About1Click(Sender);
    end;

    if (KeyDn[70]) then //F: File Menu
    begin
      ClearAllKey();
      MenuImageClick(Sender);
    end;

    if (KeyDn[72])  then//H:  Hide Form
    begin
      ClearAllKey();
      MainForm.Visible:=false;
    end;

    if (KeyDn[75]) then //K: Default Skin
    begin
      ClearAllKey();
      DefaultSkin1Click(Sender);
    end;

    if (KeyDn[80]) then //P: hide or show components
    begin
      //ClearAllKey();
      ComponetsHideShow1Click(Sender);
      KeyDn[80]:=not KeyDn[80];
    end;

    if (KeyDn[87]) then //W: set wall paper
    begin
      ClearAllKey();
      SetcurrentSkinasWallPaper1Click(Sender);
    end;

    if (KeyDn[88]) then //W: clear wall paper
    begin
      ClearAllKey();
      ClearWallPaper1Click(Sender);
    end;
  end;
end;

procedure TMainForm.MenuImageClick(Sender: TObject);
var
  ScrXY,cltXY:TPoint;
begin
  //getcursorpos(scrxY); //Get current mouse client position;
  cltXY.x:=MenuImage.Left+16;
  cltXY.y:=MenuImage.Top+16;
  cltXY:=ClientToScreen(cltXY);
  fileMenu.Popup(cltXY.x,cltXY.y);
end;

procedure TMainForm.lbxSourceKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i:integer;
begin
  if KeyDn[17] then
  begin
    if Key=65 then
    with lbxSource do
    for i:=0 to Items.Count-1 do Selected[i]:=true;

    if Key=68 then
    with lbxSource do
    for i:=0 to Items.Count-1 do Selected[i]:=false;
  end;

end;

procedure TMainForm.lbxTargetKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i:integer;
begin
  if KeyDn[17] then
  begin
    if Key=65 then
    with lbxTarget do
    for i:=0 to Items.Count-1 do Selected[i]:=true;

    if Key=68 then
    with lbxTarget do
    for i:=0 to Items.Count-1 do Selected[i]:=false;
  end;

end;

procedure TMainForm.DefaultSkin1Click(Sender: TObject);
begin
  BackGroundBitmap.LoadFromResourceName(hInstance, 'BACKGROUND');
  FormPaint(Sender);
end;

procedure TMainForm.cmAboutClick(Sender: TObject);
begin
  About1Click(Sender);
end;

procedure TMainForm.TimelyChange1Click(Sender: TObject);
begin
  TimelyChange:=not TimelyChange;
  if TimelyChange then TimelyChange1.Checked:=true
  else  TimelyChange1.Checked:=false;
end;

function GetFptrByID(head,tail:Fileptr; Id:word):Fileptr;
var
  i:word;
  fptr:Fileptr;
begin
  fptr:=head;
  i:=1;
  while fptr<>nil do
  begin
    if i=Id then break;
    inc(i);
    fptr:=fptr^.next;
  end;

  result:=fptr;
end;



procedure TMainForm.lbxTargetMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  i:integer;
  fptr:Fileptr;
begin
  i:=-1;
  with lbxTarget do
  if Items.Count=0 then exit
  else
  begin
    i:=ItemAtPos(Point(X,Y),true);
    if i>=0 then
      case lbxTargetListType of
      Folders:
        begin
          lbStatus.Caption:=curPrj^.prjtgtdir+'\'+Items[i];
        end;
      Files:
        begin
          fptr:=GetFptrById(bhead,btail,i+1);
          if fptr<>nil then
          begin
            lbStatus.Caption:=fptr^.fn;
          end;
        end;
      end
    else lbStatus.Caption:='';
  end;
end;

procedure TMainForm.btnBackPrjDirClick(Sender: TObject);
begin
  if lbxTargetListType=Files then ListBackUpDirs(curPrj^.prjTgtDir);
  if lbxTarget.Visible then lbxTarget.SetFocus;
end;

procedure TMainForm.lbxTargetDblClick(Sender: TObject);
var
  i:word;
  BackUpDir:String;
  curb:Fileptr;
begin
  //
  Case lbxTargetListType of
  Folders:
    begin
      with lbxTarget do
      if Items.Count=0 then exit
      else
      for i:=0 to Items.Count-1 do
      if selected[i] then
      begin
        BackUpDir:=curPrj^.prjTgtDir+'\'+Items[i];
        break;
      end;
      GetBackUpFiles(BackUpDir,bhead,btail);
      ListBackUpFiles(bhead,btail);
    end;
  Files:
    with lbxTarget do
    if Items.Count=0 then exit
    else
    for i:=0 to Items.Count-1 do
    if selected[i] then
    begin
      curb:=GetFptr(bhead,btail,i);
      if curb<>nil then
      if FileExists(curb^.Fn) then
      begin
        ShellExecute(0, nil, pchar(curb^.fn), nil, nil, SW_SHOWNORMAL);
        break;
      end;
    end;
  end;
end;

procedure TMainForm.lbxtMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  i,j:integer;
begin
  with Sender as TListBox do
  if Items.Count<>0 then
  begin
    i:=ItemAtPos(Point(X,Y),true);
    if i<0 then // i<0 ---> not in any itemRect
    begin
      lbStatus.Caption:='';
      for j:=0 to Items.Count-1 do
        Selected[j]:=false;
    end;
  end;
end;

procedure TMainForm.lbxSourceMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  i:integer;
  ListBoxItem:TRect;
  fptr:Fileptr;
begin
  with lbxSource do
  if Items.Count=0 then exit
  else 
  begin
    i:=ItemAtPos(Point(X,Y),true); //pGbItem -> false: |Ǧ^̫@Index. true: |Ǧ^
    if i>=0 then
    begin
      fptr:=GetFptrById(fhead,ftail,i+1);
      if fptr<>nil then
      begin
        lbStatus.Caption:=fptr^.fn;
      end;
    end
    else lbStatus.Caption:='';
  end;  
end;

procedure TMainForm.RoundedWindow1Click(Sender: TObject);
begin
  MakeRoundedWindow(MainForm,200);
end;


procedure TMainForm.ShowBkgndPic(blShow:Boolean);
begin
  with MainForm do
  begin
    MinImage.Visible:=blShow;
    CloseImage.Visible:=blShow;
    PnlClock.Visible:=blShow;
    cbxProjects.Visible:=blShow;
    stTarget.Visible:=blShow;
    lbxSource.Visible:=blShow;
    edBkUp.Visible:=blShow;
    lbxTarget.Visible:=blShow;
    btnBackPrjDir.Visible:=blShow;
    edTarget.Visible:=blShow;
    btnBackUp.Visible:=blShow;
    btnAdd.Visible:=blShow;
    btnDelete.Visible:=blShow;
    btnRestore.Visible:=blShow;
    btnDelBkUp.Visible:=blShow;
    btnselDir.Visible:=blShow;
    lbStatus.Visible:=blShow;
    PnlAutoBkUp.Visible:=blShow;
  end;
end;

procedure TMainForm.ComponetsHideShow1Click(Sender: TObject);
begin
  ShowComponents:=not ShowComponents;
  ShowBkgndPic(ShowComponents);
end;

procedure TMainForm.SetcurrentSkinasWallPaper1Click(Sender: TObject);
var
  FName:String;
begin
  FName:=AppDir+format('\Skin\EzBkUpSkin%d.bmp',[ImageID]);
  if fileexists(FName) then
  SystemParametersInfo(SPI_SETDESKWALLPAPER, 0,
                       PChar(FName),
                       SPIF_SENDWININICHANGE);
end;

procedure TMainForm.ClearWallPaper1Click(Sender: TObject);
var
  FName:String;
begin
  FName:=AppDir+format('\Skin\EzBkUpSkin%d.bmp',[ImageID]);
  if fileexists(FName) then
  SystemParametersInfo(SPI_SETDESKWALLPAPER, 0,
                       nil,
                       SPIF_SENDWININICHANGE);
end;

procedure TMainForm.cbxProjectsChange(Sender: TObject); 
begin
   curPrj:=GetPrjptr(Prjhead,Prjtail,cbxProjects.ItemIndex);
   //cbxProjects.ItemIndex:=GetIndex(prjhead,prjtail,curPrj);
   RefreshInterface;
end;

procedure TMainForm.RunEzBkUponWindowsStartUp1Click(Sender: TObject);
begin
  if _isNT then
    RegisterWin32
  else
    RegisterWin16;
end;

procedure TMainForm.DisableAutoStarUp1Click(Sender: TObject);
begin
  UnRegisterWin32;
end;

procedure TMainForm.lbxSourceDblClick(Sender: TObject);
var
  i:integer;
  curf:Fileptr;
begin
  with lbxSource do
  if Items.Count=0 then exit
  else
  for i:=0 to Items.Count-1 do
  if selected[i] then
  begin
    curf:=GetFptr(fhead,ftail,i);
    if curf<>nil then
    if FileExists(curf^.fn) then
    begin
      ShellExecute(0, nil, pchar(curf^.fn), nil, nil, SW_SHOWNORMAL);
      break;
    end;
  end;
end;

procedure TMainForm.DosMode1Click(Sender: TObject);
begin
  DosMode;
end;

procedure TMainForm.HideIE1Click(Sender: TObject);
var
  TheWindowHandle : THandle;
begin
  TheWindowHandle := FindAWindow('Welcome To HiNet - MicroSsoft Internet Explorer', '');
  if TheWindowHandle = 0 then
    ShowMessage('Window Not Found!')
  else
    ShowWindow(TheWindowHandle,SW_HIDE);
    //BringWindowToTop(TheWindowHandle);
end;

procedure TMainForm.ScreenSaverOn1Click(Sender: TObject);
begin
  if TurnScreenSaverOn then
  else
    ShowMessage('Can not turn on Screen Saver');
end;

end.


